/***************************************************************************
                          kxsnac.h  -  description
                             -------------------
    begin                : Mon Nov 12 2001
    copyright            : (C) 2001 by Herwin Jan Steehouwer
    email                : steehouwer@kde.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KXSNAC_H
#define KXSNAC_H

#include <qlist.h>
#include <qdatastream.h>

  const Q_UINT16 SNAC_FAM_GEN = 0x0001;
  const Q_UINT16 SNAC_FAM_LOC = 0x0002;
  const Q_UINT16 SNAC_FAM_BUD = 0x0003;
  const Q_UINT16 SNAC_FAM_MSG = 0x0004;
  const Q_UINT16 SNAC_FAM_ADS = 0x0005;
  const Q_UINT16 SNAC_FAM_INV = 0x0006;
  const Q_UINT16 SNAC_FAM_ADM = 0x0007;
  const Q_UINT16 SNAC_FAM_POP = 0x0008;
  const Q_UINT16 SNAC_FAM_BOS = 0x0009;
  const Q_UINT16 SNAC_FAM_LUP = 0x000a;
  const Q_UINT16 SNAC_FAM_STS = 0x000b;
  const Q_UINT16 SNAC_FAM_TRT = 0x000c;
  const Q_UINT16 SNAC_FAM_CNV = 0x000d;
  const Q_UINT16 SNAC_FAM_CHT = 0x000e;
  const Q_UINT16 SNAC_FAM_SRV = 0x0015;

/**
  *@author Herwin Jan Steehouwer
  */

class kxSNAC {
public: 
	kxSNAC();
	~kxSNAC();
	
	Q_UINT32 requestID;
  /** No descriptions */
  int addSNACHeader(QDataStream *s, Q_UINT16, Q_UINT16, Q_UINT32 seq=0, Q_UINT8 flag0=0, Q_UINT8 flag0=0);
	
	void parseSNAC( QDataStream *s, int len);
};

#endif
